from random import choice

directions = [(1,0),(0,1),(-1,0),(0,-1)]

def marche(dimensions, source, but):
    dimx,dimy = dimensions
    chemin = [source]
    x,y = source
    while (x,y) != but:
        dx,dy = choice(directions)
        x = x+dx
        y = y+dy
        if x<0:
            x=0
        elif x>dimx:
            x=dimx
        if y<0:
            y=0
        elif y>dimy:
            y=dimy
        chemin.append((x,y))
    return chemin

if __name__ == '__main__':
    dimensions = (48,36)
    source = (24,18)
    but = (48,36)
    nb_essais = 1000
    print('on va faire',nb_essais,'marches aléatoires de',source,'à',but,'dans une boîte de dimensions',dimensions)
    input('appuyez sur <Entrée> pour démarrer')
    total = 0
    max_pas = 0
    for i in range(nb_essais):
        print('marche n°',i,':')
        pas = len(marche(dimensions,source,but))
        max_pas = max(pas,max_pas)
        total = total + pas
        print('  -> but atteint après',pas,'pas')
    print('nombre moyen de pas :',total/nb_essais)
    print('nombre maximum de pas :',max_pas)




    

